Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/mpp.f90	(revision 5213)
@@ -2746,52 +2976,80 @@
 
       ! loop indices
-      INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
       CALL logger_info( &
-      &  " CLEAN: reset mpp "//TRIM(td_mpp%c_name) )
+      &  "MPP CLEAN: reset mpp "//TRIM(td_mpp%c_name) )
 
       ! del dimension
       IF( td_mpp%i_ndim /= 0 )THEN
-         DO ji=td_mpp%i_ndim,1,-1
-            CALL dim_clean( td_mpp%t_dim(ji) )
-         ENDDO
+         CALL dim_clean( td_mpp%t_dim(:) )
       ENDIF
 
       IF( ASSOCIATED(td_mpp%t_proc) )THEN
-         ! clean each proc
-         DO ji=1,td_mpp%i_nproc
-            CALL file_clean( td_mpp%t_proc(ji) )
-         ENDDO
+         ! clean array of file processor
+         CALL file_clean( td_mpp%t_proc(:) )
          DEALLOCATE(td_mpp%t_proc)
       ENDIF
 
       ! replace by empty structure
-      td_mpp=tl_mpp
-
-   END SUBROUTINE mpp_clean
-   !> @endcode
+      td_mpp=mpp_copy(tl_mpp)
+
+   END SUBROUTINE mpp__clean_unit
+   !-------------------------------------------------------------------
+   !> @brief 
+   !>  This subroutine clean mpp strcuture.
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
+   SUBROUTINE mpp__clean_arr( td_mpp )
+      IMPLICIT NONE
+      ! Argument
+      TYPE(TMPP),  DIMENSION(:), INTENT(INOUT) :: td_mpp
+
+      ! local variable
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+
+      DO ji=SIZE(td_mpp(:)),1,-1
+         CALL mpp_clean(td_mpp(ji))
+      ENDDO
+
+   END SUBROUTINE mpp__clean_arr
    !-------------------------------------------------------------------
    !> @brief 
    !>  This subroutine get sub domains which cover "zoom domain".
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @param[in] td_dom : domain strcuture
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE mpp_get_use( td_mpp, td_dom )
+   !>
+   !> @author J.Paul
+   !> @date November, 2013 - Initial version
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !> @param[in] id_imin   i-direction lower indice
+   !> @param[in] id_imax   i-direction upper indice
+   !> @param[in] id_jmin   j-direction lower indice
+   !> @param[in] id_jmax   j-direction upper indice
+   !-------------------------------------------------------------------
+   SUBROUTINE mpp__get_use_unit( td_mpp, id_imin, id_imax, &
+   &                                     id_jmin, id_jmax )
       IMPLICIT NONE
       ! Argument
-      TYPE(TMPP),  INTENT(INOUT) :: td_mpp
-      TYPE(TDOM),  INTENT(IN)    :: td_dom
+      TYPE(TMPP) ,  INTENT(INOUT) :: td_mpp
+      INTEGER(i4),  INTENT(IN), OPTIONAL :: id_imin
+      INTEGER(i4),  INTENT(IN), OPTIONAL :: id_imax
+      INTEGER(i4),  INTENT(IN), OPTIONAL :: id_jmin
+      INTEGER(i4),  INTENT(IN), OPTIONAL :: id_jmax
 
       ! local variable
-      INTEGER(i4) :: il_jmin
       LOGICAL     :: ll_iuse
       LOGICAL     :: ll_juse
 
+      INTEGER(i4) :: il_imin
+      INTEGER(i4) :: il_imax
+      INTEGER(i4) :: il_jmin
+      INTEGER(i4) :: il_jmax
+
       ! loop indices
       INTEGER(i4) :: jk
@@ -2799,8 +3057,27 @@
       IF( ASSOCIATED(td_mpp%t_proc) )THEN
    
+         il_imin=1
+         il_imax=td_mpp%t_dim(1)%i_len
+         IF( PRESENT(id_imin) ) il_imin=id_imin
+         IF( PRESENT(id_imax) ) il_imax=id_imax
+         il_jmin=1
+         il_jmax=td_mpp%t_dim(2)%i_len
+         IF( PRESENT(id_jmin) ) il_jmin=id_jmin
+         IF( PRESENT(id_jmax) ) il_jmax=id_jmax
+
          ! check domain
-         IF( td_mpp%t_dim(1)%i_len == td_dom%t_dim0(1)%i_len .AND. &
-         &   td_mpp%t_dim(2)%i_len == td_dom%t_dim0(2)%i_len )THEN
-
+         IF( il_imin < 1 .OR. il_imin > td_mpp%t_dim(1)%i_len .OR. &
+         &   il_imax < 1 .OR. il_imax > td_mpp%t_dim(1)%i_len .OR. &
+         &   il_jmin < 1 .OR. il_jmin > td_mpp%t_dim(2)%i_len .OR. &
+         &   il_jmax < 1 .OR. il_jmax > td_mpp%t_dim(2)%i_len )THEN
+            CALL logger_debug("MPP GET USE: mpp gloabl size "//&
+            &        TRIM(fct_str(td_mpp%t_dim(1)%i_len))//","//&
+            &        TRIM(fct_str(td_mpp%t_dim(2)%i_len)))
+            CALL logger_debug("MPP GET USE: i-indices "//&
+            &        TRIM(fct_str(il_imin))//","//TRIM(fct_str(il_imax)))
+            CALL logger_debug("MPP GET USE: j-indices "//&
+            &        TRIM(fct_str(il_jmin))//","//TRIM(fct_str(il_jmax)))
+            CALL logger_error("MPP GET USE: invalid indices ")
+         ELSE
             td_mpp%t_proc(:)%l_use=.FALSE.
             DO jk=1,td_mpp%i_nproc
@@ -2808,28 +3085,25 @@
                ! check i-direction
                ll_iuse=.FALSE.
-               IF( td_dom%i_imin < td_dom%i_imax )THEN
+               IF( il_imin < il_imax )THEN
 
                   ! not overlap east west boundary
                   IF( td_mpp%t_proc(jk)%i_impp + td_mpp%t_proc(jk)%i_lci > &
-                  &   td_dom%i_imin .AND.                                  &
-                  &   td_mpp%t_proc(jk)%i_impp < td_dom%i_imax )THEN
+                  &   il_imin .AND.                                  &
+                  &   td_mpp%t_proc(jk)%i_impp < il_imax )THEN
                       ll_iuse=.TRUE.
                   ENDIF
 
-               ELSEIF( td_dom%i_imin == td_dom%i_imax )THEN
+               ELSEIF( il_imin == il_imax )THEN
 
                   ! east west cyclic
                   ll_iuse=.TRUE.
 
-               ELSE ! td_dom%i_imin > td_dom%i_imax
+               ELSE ! il_imin > id_imax
 
                   ! overlap east west boundary
                   IF( ( td_mpp%t_proc(jk)%i_impp + td_mpp%t_proc(jk)%i_lci >  &
-                  &     td_dom%i_imin .AND.                                   &
-                  &     td_mpp%t_proc(jk)%i_impp < td_dom%t_dim0(1)%i_len )    &
+                  &     il_imin )                                             &
                   &   .OR.                                                    &
-                  &   ( td_mpp%t_proc(jk)%i_impp + td_mpp%t_proc(jk)%i_lci >  &
-                  &     1 .AND.                                               &
-                  &     td_mpp%t_proc(jk)%i_impp < td_dom%i_imax) )THEN
+                  &   ( td_mpp%t_proc(jk)%i_impp < il_imax) )THEN
                      ll_iuse=.TRUE.
                   ENDIF
@@ -2839,16 +3113,15 @@
                ! check j-direction
                ll_juse=.FALSE.
-               IF( td_dom%i_jmin < td_dom%i_jmax )THEN
+               IF( il_jmin < il_jmax )THEN
 
                   ! not overlap north fold
                   IF( td_mpp%t_proc(jk)%i_jmpp + td_mpp%t_proc(jk)%i_lcj > &
-                  &   td_dom%i_jmin .AND.                                  &
-                  &   td_mpp%t_proc(jk)%i_jmpp < td_dom%i_jmax )THEN
+                  &   il_jmin .AND.                                  &
+                  &   td_mpp%t_proc(jk)%i_jmpp < il_jmax )THEN
                      ll_juse=.TRUE.
                   ENDIF
 
-               ELSE ! td_dom%i_jmin >= td_dom%i_jmax
-
-                  il_jmin=MIN(td_dom%i_jmin,td_dom%i_jmax)
+               ELSE ! id_jmin >= id_jmax
+
                   IF( td_mpp%t_proc(jk)%i_jmpp + td_mpp%t_proc(jk)%i_lcj > &
                   &  il_jmin )THEN
@@ -2861,24 +3134,20 @@
 
             ENDDO
-         ELSE
-            CALL logger_error("GET USE: domain differ")
          ENDIF
 
       ELSE
-         CALL logger_error("GET USE: domain decomposition not define.")
-      ENDIF
-
-   END SUBROUTINE mpp_get_use
-   !> @endcode
+         CALL logger_error("MPP GET USE: mpp decomposition not define.")
+      ENDIF
+
+   END SUBROUTINE mpp__get_use_unit
    !-------------------------------------------------------------------
    !> @brief 
    !>  This subroutine get sub domains which form global domain border.
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !-------------------------------------------------------------------
-   !> @code
+   !>
+   !> @author J.Paul
+   !> @date November, 2013
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_get_contour( td_mpp )
       IMPLICIT NONE
@@ -2892,5 +3161,5 @@
       IF( ASSOCIATED(td_mpp%t_proc) )THEN
 
-         td_mpp%t_proc(:)%l_ctr = .FALSE.
+         td_mpp%t_proc(:)%l_use = .FALSE.
          DO jk=1,td_mpp%i_nproc
             IF( td_mpp%t_proc(jk)%i_ldi == 1 .OR. &
@@ -2899,33 +3168,31 @@
             &   td_mpp%t_proc(jk)%i_lej == td_mpp%t_proc(jk)%i_lcj )THEN
 
-               td_mpp%t_proc(jk)%l_ctr = .TRUE.
-            
+               td_mpp%t_proc(jk)%l_use = .TRUE.
+ 
             ENDIF
          ENDDO
    
       ELSE
-         CALL logger_error("GET CONTOUR: domain decomposition not define.")
+         CALL logger_error("MPP GET CONTOUR: domain decomposition not define.")
       ENDIF
 
    END SUBROUTINE mpp_get_contour
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
    !> This function return processor indices, without overlap boundary,
-   !> given processor id. This depends of domain decompisition type. 
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[in] td_mpp : mpp strcuture
-   !> @param[in] id_procid : processor id
-   !> @return table of index (/ i1, i2, j1, j2 /)
-   !-------------------------------------------------------------------
-   !> @code
+   !> given processor id. 
+   !>
+   !> @author J.Paul
+   !> @date November, 2013
+   !>
+   !> @param[in] td_mpp    mpp strcuture
+   !> @param[in] id_procid processor id
+   !> @return array of index (/ i1, i2, j1, j2 /)
+   !-------------------------------------------------------------------
    FUNCTION mpp_get_proc_index( td_mpp, id_procid )
       IMPLICIT NONE
 
       ! Argument
-      TYPE(TMPP),  INTENT(IN) :: td_mpp
+      TYPE(TMPP) , INTENT(IN) :: td_mpp
       INTEGER(i4), INTENT(IN) :: id_procid
 
@@ -2936,18 +3203,14 @@
       INTEGER(i4) :: il_i1, il_i2
       INTEGER(i4) :: il_j1, il_j2
-      TYPE(TMPP)  :: tl_mpp
       !----------------------------------------------------------------
 
       IF( ASSOCIATED(td_mpp%t_proc) )THEN
 
-         tl_mpp=td_mpp
-         !IF( TRIM(td_mpp%c_dom) == "unknown" )THEN
          IF( TRIM(td_mpp%c_dom) == '' )THEN
-            CALL logger_warn("GET PROC INDEX: decomposition type unknown. "//&
-            &             "look for it")
-            CALL mpp_get_dom( tl_mpp )
+            CALL logger_fatal("MPP GET PROC INDEX: decomposition type unknown. "//&
+            &                 "you should ahve run mpp_get_dom before.")
          ENDIF
 
-         SELECT CASE(TRIM(tl_mpp%c_dom))
+         SELECT CASE(TRIM(td_mpp%c_dom))
             CASE('full')
                il_i1 = 1 ; il_i2 = td_mpp%t_dim(1)%i_len
@@ -2957,5 +3220,5 @@
                 il_j1 = td_mpp%t_proc(id_procid)%i_jmpp
 
-                il_i2 = il_i1 + td_mpp%t_proc(id_procid)%i_lci - 1 ! attention lei dans ioRestartDimg
+                il_i2 = il_i1 + td_mpp%t_proc(id_procid)%i_lci - 1 
                 il_j2 = il_j1 + td_mpp%t_proc(id_procid)%i_lcj - 1 
             CASE('nooverlap')
@@ -2970,5 +3233,5 @@
                &        td_mpp%t_proc(id_procid)%i_lej - 1
             CASE DEFAULT
-               CALL logger_error("GET PROC INDEX: invalid decomposition type.")
+               CALL logger_error("MPP GET PROC INDEX: invalid decomposition type.")
          END SELECT
 
@@ -2976,9 +3239,8 @@
 
       ELSE
-         CALL logger_error("GET PROC INDEX: domain decomposition not define.")
+         CALL logger_error("MPP GET PROC INDEX: domain decomposition not define.")
       ENDIF
 
    END FUNCTION mpp_get_proc_index
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief
@@ -2987,11 +3249,10 @@
    !
    !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[in] td_mpp : mpp strcuture
-   !> @param[in] id_procid : sub domain id
-   !> @return table of index (/ isize, jsize /)
-   !-------------------------------------------------------------------
-   !> @code
+   !> @date November, 2013
+   !
+   !> @param[in] td_mpp    mpp strcuture
+   !> @param[in] id_procid sub domain id
+   !> @return array of index (/ isize, jsize /)
+   !-------------------------------------------------------------------
    FUNCTION mpp_get_proc_size( td_mpp, id_procid )
       IMPLICIT NONE
@@ -3007,18 +3268,14 @@
       INTEGER(i4) :: il_isize
       INTEGER(i4) :: il_jsize
-      TYPE(TMPP)  :: tl_mpp
       !----------------------------------------------------------------
 
       IF( ASSOCIATED(td_mpp%t_proc) )THEN
 
-         tl_mpp=td_mpp
-         !IF( TRIM(td_mpp%c_dom) == "unknown" )THEN
          IF( TRIM(td_mpp%c_dom) == '' )THEN
-            CALL logger_warn("GET PROC SIZE: decomposition type unknown. "//&
-            &              "look for it")
-            CALL mpp_get_dom( tl_mpp )
+            CALL logger_fatal("MPP GET PROC SIZE: decomposition type unknown. "//&
+            &                 "you should ahve run mpp_get_dom before.")
          ENDIF
 
-         SELECT CASE(TRIM(tl_mpp%c_dom))
+         SELECT CASE(TRIM(td_mpp%c_dom))
             CASE('full')
                
@@ -3037,6 +3294,6 @@
                &          td_mpp%t_proc(id_procid)%i_ldj + 1
             CASE DEFAULT
-               CALL logger_error("GET PROC SIZE: invalid decomposition type : "//&
-               &  TRIM(tl_mpp%c_dom) )
+               CALL logger_error("MPP GET PROC SIZE: invalid decomposition type : "//&
+               &  TRIM(td_mpp%c_dom) )
          END SELECT
 
@@ -3044,22 +3301,18 @@
 
       ELSE
-         CALL logger_error("GET PROC SIZE: domain decomposition not define.")
+         CALL logger_error("MPP GET PROC SIZE: domain decomposition not define.")
       ENDIF
 
    END FUNCTION mpp_get_proc_size
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief 
    !>  This subroutine determine domain decomposition type.
    !>  (full, overlap, noverlap)
-   !
-   !> @author J.Paul
-   !> @date Nov, 2013
-   !
-   !> @param[inout] td_mpp : mpp strcuture
-   !> @todo
-   !> - change name, confusing with domain.f90
-   !-------------------------------------------------------------------
-   !> @code
+   !>
+   !> @author J.Paul
+   !> @date November, 2013
+   !>
+   !> @param[inout] td_mpp mpp strcuture
+   !-------------------------------------------------------------------
    SUBROUTINE mpp_get_dom( td_mpp )
       IMPLICIT NONE
@@ -3075,5 +3328,5 @@
 
          IF( td_mpp%i_niproc == 0 .AND. td_mpp%i_niproc == 0 )THEN
-            CALL logger_info("GET DOM: use indoor indices to get domain "//&
+            CALL logger_info("MPP GET DOM: use indoor indices to get domain "//&
             &             "decomposition type.")
             IF((td_mpp%t_proc(1)%t_dim(1)%i_len ==                         &
@@ -3100,24 +3353,24 @@
             ELSE
 
-               CALL logger_error("GET DOM: should have been an impossible case")
+               CALL logger_error("MPP GET DOM: should have been an impossible case")
 
                il_isize=td_mpp%t_proc(1)%t_dim(1)%i_len
                il_jsize=td_mpp%t_proc(1)%t_dim(2)%i_len
-               CALL logger_debug("GET DOM: proc size "//&
+               CALL logger_debug("MPP GET DOM: proc size "//&
                &  TRIM(fct_str(il_isize))//" x "//TRIM(fct_str(il_jsize)) )
 
                il_isize=td_mpp%t_proc(1)%i_lei - td_mpp%t_proc(1)%i_ldi + 1
                il_jsize=td_mpp%t_proc(1)%i_lej - td_mpp%t_proc(1)%i_ldj + 1
-               CALL logger_debug("GET DOM: no overlap size "//&
+               CALL logger_debug("MPP GET DOM: no overlap size "//&
                &  TRIM(fct_str(il_isize))//" x "//TRIM(fct_str(il_jsize)) )
 
                il_isize=td_mpp%t_proc(1)%i_lci
                il_jsize=td_mpp%t_proc(1)%i_lcj
-               CALL logger_debug("GET DOM: overlap size "//&
+               CALL logger_debug("MPP GET DOM: overlap size "//&
                &  TRIM(fct_str(il_isize))//" x "//TRIM(fct_str(il_jsize)) )
 
                il_isize=td_mpp%t_dim(1)%i_len
                il_jsize=td_mpp%t_dim(2)%i_len
-               CALL logger_debug("GET DOM: full size "//&
+               CALL logger_debug("MPP GET DOM: full size "//&
                &  TRIM(fct_str(il_isize))//" x "//TRIM(fct_str(il_jsize)) )
 
@@ -3126,5 +3379,5 @@
          ELSE
 
-            CALL logger_info("GET DOM: use number of processors following "//&
+            CALL logger_info("MPP GET DOM: use number of processors following "//&
             &             "I and J to get domain decomposition type.")
             IF( td_mpp%i_niproc*td_mpp%i_njproc==td_mpp%i_nproc )THEN
@@ -3140,23 +3393,21 @@
 
       ELSE
-         CALL logger_error("GET DOM: domain decomposition not define.")
+         CALL logger_error("MPP GET DOM: domain decomposition not define.")
       ENDIF
 
    END SUBROUTINE mpp_get_dom
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function check if variable  and mpp structure use same
    !> dimension.
-   !
+   !>
    !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp : mpp structure
-   !> @param[in] td_var : variable structure
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] td_mpp mpp structure
+   !> @param[in] td_var variable structure
    !> @return dimension of variable and mpp structure agree (or not)
    !-------------------------------------------------------------------
-   ! @code
    LOGICAL FUNCTION mpp__check_var_dim(td_mpp, td_var)
       IMPLICIT NONE
@@ -3179,5 +3430,5 @@
 
          CALL logger_error( &
-         &  " CHECK DIM: variable and mpp dimension differ"//&
+         &  "MPP CHECK DIM: variable and mpp dimension differ"//&
          &  " for variable "//TRIM(td_var%c_name)//&
          &  " and mpp "//TRIM(td_mpp%c_name))
@@ -3189,5 +3440,5 @@
          DO ji = 1, il_ndim
             CALL logger_debug( &
-            &  " CHECK DIM: for dimension "//&
+            &  "MPP CHECK DIM: for dimension "//&
             &  TRIM(td_mpp%t_dim(ji)%c_name)//&
             &  ", mpp length: "//&
@@ -3200,5 +3451,156 @@
 
    END FUNCTION mpp__check_var_dim
-   ! @endcode
+   !-------------------------------------------------------------------
+   !> @brief This function return the mpp id, in a array of mpp
+   !> structure,  given mpp base name. 
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   array of file structure
+   !> @param[in] cd_name   file name
+   !> @return file id in array of file structure (0 if not found)
+   !-------------------------------------------------------------------
+   INTEGER(i4) FUNCTION mpp_get_index(td_mpp, cd_name)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TMPP)      , DIMENSION(:), INTENT(IN) :: td_mpp
+      CHARACTER(LEN=*),               INTENT(IN) :: cd_name
+
+      ! local variable
+      CHARACTER(LEN=lc) :: cl_name
+      INTEGER(i4)       :: il_size
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      mpp_get_index=0
+      il_size=SIZE(td_mpp(:))
+
+      cl_name=TRIM( file_rename(cd_name) )
+
+      ! check if mpp is in array of mpp structure
+      DO ji=1,il_size
+         ! look for file name
+         IF( TRIM(fct_lower(td_mpp(ji)%c_name)) == TRIM(fct_lower(cd_name)) )THEN
+ 
+            mpp_get_index=ji
+            EXIT
+
+         ENDIF
+      ENDDO
+
+   END FUNCTION mpp_get_index
+   !-------------------------------------------------------------------
+   !> @brief This function recombine variable splitted mpp structure. 
+   !
+   !> @author J.Paul
+   !> - Ocotber, 2014- Initial Version
+   !
+   !> @param[in] td_mpp   mpp file structure
+   !> @param[in] cd_name  variable name
+   !> @return variable strucutre
+   !-------------------------------------------------------------------
+   TYPE(TVAR) FUNCTION mpp_recombine_var(td_mpp, cd_name) 
+   IMPLICIT NONE
+      ! Argument      
+      TYPE(TMPP)      , INTENT(IN) :: td_mpp
+      CHARACTER(LEN=*), INTENT(IN) :: cd_name
+
+      ! local variable
+      INTEGER(i4)                       :: il_varid
+      INTEGER(i4)                       :: il_status
+      INTEGER(i4)                       :: il_i1p
+      INTEGER(i4)                       :: il_i2p
+      INTEGER(i4)                       :: il_j1p
+      INTEGER(i4)                       :: il_j2p
+      INTEGER(i4), DIMENSION(4)         :: il_ind
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_strt
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_cnt
+
+      TYPE(TVAR)                        :: tl_tmp
+      TYPE(TVAR)                        :: tl_var
+
+      ! loop indices
+      INTEGER(i4) :: ji
+      INTEGER(i4) :: jk
+      !----------------------------------------------------------------
+
+      il_varid=var_get_index( td_mpp%t_proc(1)%t_var(:), cd_name)
+      IF( il_varid /= 0 )THEN
+      
+         tl_var=var_copy(td_mpp%t_proc(1)%t_var(il_varid))
+         ! Allocate space to hold variable value in structure 
+         IF( ASSOCIATED(tl_var%d_value) )THEN
+            DEALLOCATE(tl_var%d_value)   
+         ENDIF
+         ! 
+         DO ji=1,ip_maxdim
+            IF( tl_var%t_dim(ji)%l_use )THEN
+               tl_var%t_dim(ji)%i_len=td_mpp%t_dim(ji)%i_len
+            ENDIF
+         ENDDO
+
+         ALLOCATE(tl_var%d_value( tl_var%t_dim(1)%i_len, &
+         &                        tl_var%t_dim(2)%i_len, &
+         &                        tl_var%t_dim(3)%i_len, &
+         &                        tl_var%t_dim(4)%i_len),&
+         &        stat=il_status)
+         IF(il_status /= 0 )THEN
+
+           CALL logger_error( &
+            &  " MPP RECOMBINE VAR: not enough space to put variable "//&
+            &  TRIM(tl_var%c_name)//" in variable structure")
+
+         ENDIF
+
+         ! FillValue by default
+         tl_var%d_value(:,:,:,:)=tl_var%d_fill
+
+         ! read processor 
+         DO jk=1,td_mpp%i_nproc
+            IF( td_mpp%t_proc(jk)%l_use )THEN
+               ! get processor indices
+               il_ind(:)=mpp_get_proc_index( td_mpp, jk )
+               il_i1p = il_ind(1)
+               il_i2p = il_ind(2)
+               il_j1p = il_ind(3)
+               il_j2p = il_ind(4)
+ 
+               il_strt(:)=(/ 1,1,1,1 /)
+
+               il_cnt(:)=(/ il_i2p-il_i1p+1,         &
+               &            il_j2p-il_j1p+1,         &
+               &            tl_var%t_dim(3)%i_len, &
+               &            tl_var%t_dim(4)%i_len /)
+
+               tl_tmp=iom_read_var( td_mpp%t_proc(jk), tl_var%c_name,&
+               &                    il_strt(:), il_cnt(:) )
+               
+               ! replace value in output variable structure
+               tl_var%d_value( il_i1p : il_i2p,  &
+               &               il_j1p : il_j2p,  &
+               &               :,:) = tl_tmp%d_value(:,:,:,:)
+
+               ! clean
+               CALL var_clean(tl_tmp)
+
+            ENDIF
+         ENDDO
+
+         mpp_recombine_var=var_copy(tl_var)
+
+         ! clean
+         CALL var_clean(tl_var)
+
+      ELSE
+
+         CALL logger_error( &
+         &  " MPP RECOMBINE VAR: there is no variable with "//&
+         &  "name or standard name"//TRIM(cd_name)//&
+         &  " in mpp file "//TRIM(td_mpp%c_name))
+      ENDIF
+   END FUNCTION mpp_recombine_var
 END MODULE mpp
 
